//
//  ATPHomeViewController.m
//  AskThePenguin
//
//  Created by Nikša Vlahušić on 12/04/14.
//  Copyright (c) 2014 FUTURA. All rights reserved.
//

#import "ATPHomeViewController.h"
#import "ATPHistoryViewController.h"

@interface ATPHomeViewController ()

@end

@implementation ATPHomeViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
        
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(applicationWillEnterForeground:) name:UIApplicationWillEnterForegroundNotification object:nil];
    }
    return self;
}

- (void)viewDidLoad {
    
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewWillAppear:(BOOL)animated {
    
    [super viewWillAppear:animated];
    [self resetView];
}

- (void)didReceiveMemoryWarning {
    
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


#pragma mark - NSNotificationCenter delegate methods

- (void)applicationWillEnterForeground:(UIApplication *)application {
    
    [self resetView];
}


#pragma mark - Helper methods

- (void)resetView {
    
    if ([self.textFieldQuestion isFirstResponder]) {
        [self.textFieldQuestion resignFirstResponder];
    }
    self.textFieldQuestion.text = @"";
    self.imageViewNo.hidden = YES;
    self.imageViewYes.hidden = YES;
}


#pragma mark - Actions methods

- (IBAction)buttonAskMeNowTouchUpInside:(id)sender {
    
    if (self.textFieldQuestion.text.length) {
        int random = arc4random() % 2;
        if (random == 0) {
            self.imageViewNo.hidden = NO;
            self.imageViewYes.hidden = YES;
        } else {
            self.imageViewYes.hidden = NO;
            self.imageViewNo.hidden = YES;
        }
        
        if ([self.textFieldQuestion isFirstResponder]) {
            [self.textFieldQuestion resignFirstResponder];
        }
        
        //Spremanje podataka
        NSString *response;
        if (random == 0) {
            response = @"No";
        } else {
            response = @"Yes";
        }
        NSString *question = self.textFieldQuestion.text;
        
        NSMutableDictionary *QR = [NSMutableDictionary dictionary];
        [QR setObject:response forKey:@"response"];
        [QR setObject:question forKey:@"question"];
        
        NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
        NSArray *oldQRs = [userDefaults arrayForKey:@"QRs"];
        
        NSMutableArray *QRs = [NSMutableArray array];
        if (oldQRs.count) {
            [QRs addObjectsFromArray:oldQRs];
        }
        [QRs addObject:QR];
        [userDefaults setObject:QRs forKey:@"QRs"];
        [userDefaults synchronize];
    }
}

- (IBAction)buttonHistoryTouchUpInside:(id)sender {
    
    ATPHistoryViewController *historyViewController = [[ATPHistoryViewController alloc] initWithNibName:@"ATPHistoryViewController" bundle:nil];
    [self presentViewController:historyViewController animated:YES completion:NULL];
}


#pragma mark - UITextFieldDelegate methods

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
    
    [textField resignFirstResponder];
    return NO;
}

- (void)dealloc {
    
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIApplicationWillEnterForegroundNotification object:nil];
}

@end
